#!/bin/sh
# 
# Character Set
# 
# @ABCDEFG HIJKLMNO PQRSTUVW XYZ[_]__  !"#$%&' ()*+,-./ 01234567 89:;<=>?
# ________ ________ ________ ________ ________ ________ ________ ________
# ________ ________ ________ ________ ________ ________ ________ ________
# ________ ________ ________ ________ ________ ________ ________ ________
# @abcdefg hijklmno pqrstuvw xyz[_]__  !"#$%&' ()*+,-./ 01234567 89:;<=>?
# ________ ________ ________ ________ ________ ________ ________ ________
# ________ ________ ________ ________ ________ ________ ________ ________
# ________ ________ ________ ________ ________ ________ ________ ________

unknown="underline"
num="0 1 2 3 4 5 6 7 8 9"
upper="A B C D E F G H I J K L M N O P Q R S T U V W X Y Z"
lower="a b c d e f g h i j k l m n o p q r s t u v w x y z"
mark1="atmark"
mark2="squareopenbracket $unknown squareclosebracket $unknown $unknown"
mark3="space exclamation doublequote sharp dollar percent ampersand singlequote openbracket closebracket asterisk plus comma minus period slash"
mark4="colon semicolon lessthan equal greaterthan question"
unknown4="$unknown $unknown $unknown $unknown"
unknown16="$unknown4 $unknown4 $unknown4 $unknown4"
unknown64="$unknown16 $unknown16 $unknown16 $unknown16"

chars="$mark1 $upper $mark2 $mark3 $num $mark4"
chars="$chars $unknown64 $unknown64 $unknown64"
chars="$chars $mark1 $lower $mark2 $mark3 $num $mark4"
chars="$chars $unknown64 $unknown64 $unknown64"

cat head.c > out.c

for f in $chars; do
    file="data/$f"
echo $file
    cat $file | tail -n 1 | tr \} , | tr \; \  >> out.c
done

cat tail.c >> out.c

gcc out.c -o out
./out > chargen
